PROGRAM CREATPLS;

VAR
   INFILE, OUTFILE : TEXT;
   GAP, FACTOR, OBS : INTEGER;
   SPACE : CHAR;
   FORM, MCVS : STRING[3];
   DER : STRING[4];
   X, Y, Z : INTEGER;

BEGIN
   ASSIGN (INFILE, 'LIST.TXT');
   RESET (INFILE);
   ASSIGN (OUTFILE, 'PLSTWOAF.SAS');
   REWRITE (OUTFILE);
       WRITELN (OUTFILE, '%MACRO PLSTWOAF;');
{      WRITELN (OUTFILE, '%DO 1 %TO &MAXVARS;'); }
       WRITELN (OUTFILE);

   WHILE NOT EOF(INFILE) DO
       BEGIN
       DER := '';
       READ (INFILE, DER);
       IF DER[4] <> ' ' THEN READLN (INFILE, SPACE, FORM, SPACE, MCVS, SPACE, GAP, FACTOR)
       ELSE
                 READLN (INFILE, FORM, SPACE, MCVS, SPACE, GAP, FACTOR);
       WRITELN (OUTFILE, 'DATA TEMP; SET TOTAL;');
       WRITELN (OUTFILE, 'IF IDERIVAT = ','''', DER, '''',';');
       WRITELN (OUTFILE, 'IF IFORM = ','''', FORM, '''',';');
       WRITELN (OUTFILE, 'IF IMCVS = ','''', MCVS, '''',';');
       WRITELN (OUTFILE, 'IF IGAPS = ','''', GAP, '''',';');
       WRITELN (OUTFILE);


       WRITELN (OUTFILE, '%IF &MCOPTION = "PRO" %THEN %DO;');
       WRITELN (OUTFILE, '      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = ', FACTOR,' NOPRINT;');
       WRITELN (OUTFILE, '            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;');
       WRITELN (OUTFILE, '     OUTPUT OUT=PREDCHEMANALYTE STDXSSE=STDXSSE STDYSSE=STDYSSE P=P_CHEMANALYTE XSCORE = T;');
       WRITELN (OUTFILE, '            RUN;');
       WRITELN (OUTFILE, '%END; /* END MCOPTION = PRO */ ');
       WRITELN (OUTFILE, '    ');
       WRITELN (OUTFILE, '%ELSE %IF &MCOPTION = "SAS" %THEN %DO;');
       WRITELN (OUTFILE, '      PROC PLS DATA = TEMP NFAC = ', FACTOR,' NOPRINT;');
       WRITELN (OUTFILE, '            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;');
       WRITELN (OUTFILE, '     OUTPUT OUT = PREDCHEMANALYTE STDXSSE=STDXSSE STDYSSE=STDYSSE P = P_CHEMANALYTE XSCORE= T;');
       WRITELN (OUTFILE, '            RUN;');
       WRITELN (OUTFILE, '%END; /* END MCOPTION = SAS */ ');
       WRITELN (OUTFILE, '    ');
       WRITELN (OUTFILE, '%ELSE %DO;');
       WRITELN (OUTFILE, '      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = ', FACTOR,' NOPRINT;');
       WRITELN (OUTFILE, '            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;');
       WRITELN (OUTFILE, '     OUTPUT OUT = PREDCHEMANALYTE STDXSSE=STDXSSE STDYSSE=STDYSSE P = P_CHEMANALYTE XSCORE=T;');
       WRITELN (OUTFILE, '            RUN;');
       WRITELN (OUTFILE, '%END; /* END ELSE OPTION */ ');
       WRITELN (OUTFILE);



       WRITELN (OUTFILE, 'DATA VALIDAT; INFILE ','''','VALIDAT.PRN','''',';');
       WRITELN (OUTFILE, 'INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;' );
       WRITELN (OUTFILE, 'RUN;' );
       
       WRITELN (OUTFILE, 'PROC SORT DATA = VALIDAT;' );
       WRITELN (OUTFILE, '     BY ID;' );
       WRITELN (OUTFILE, 'RUN;' );
       WRITELN (OUTFILE, 'DATA PREDVAL; SET PREDCHEMANALYTE;' );
       WRITELN (OUTFILE, '     IF CHEMANALYTES&X NE  . THEN DELETE;' );
       WRITELN (OUTFILE, 'PROC SORT; BY ID;' );
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;' );
       WRITELN (OUTFILE, '     BY ID;' );
       WRITELN (OUTFILE, '' );

       WRITELN (OUTFILE, 'PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;' );
{       WRITELN (OUTFILE, '     BY IDERIVAT IFORM IMCVS IGAPS;' );}
       WRITELN (OUTFILE, '     VAR OANALYTE&X; WITH P_CHEMANALYTE;' );
       WRITELN (OUTFILE, 'RUN;' );
       WRITELN (OUTFILE, '' );
{       WRITELN (OUTFILE, 'TITLE "VALIDATION RESULTS";' );
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'RUN;'); }
       WRITELN (OUTFILE, 'DATA SQUAREDVALIDATION; SET VALCORROUT;' );
       WRITELN (OUTFILE, 'IF _TYPE_ = ','''','CORR','''',' THEN' );
       WRITELN (OUTFILE, '     OANALYTE&X = OANALYTE&X*OANALYTE&X;' );
       WRITELN (OUTFILE, 'ELSE ' );
       WRITELN (OUTFILE, '     DELETE;' );
{       WRITELN (OUTFILE, 'PROC SORT DATA = SQUAREDVALIDATION;' );}
{       WRITELN (OUTFILE, '     BY IDERIVAT IFORM IMCVS IGAPS;' );  }
{       WRITELN (OUTFILE, 'PROC PRINT DATA = SQUAREDVALIDATION;' );
       WRITELN (OUTFILE, '' ); }


       WRITELN (OUTFILE, 'DATA PREDVAL; SET ORIGPREDVAL;');
       WRITELN (OUTFILE, 'DIF = OANALYTE&X - P_CHEMANALYTE;');
       WRITELN (OUTFILE, 'DSQ = DIF * DIF;');
       WRITELN (OUTFILE);

       WRITELN (OUTFILE, 'PROC SUMMARY;');
       WRITELN (OUTFILE, 'VAR DIF DSQ;');
       WRITELN (OUTFILE, 'OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;');
       WRITELN (OUTFILE, 'RUN;');

       WRITELN (OUTFILE, 'DATA SUMSTATS; SET SUMVAL;');
       WRITELN (OUTFILE, 'VPRESS = SDSQ;');
       WRITELN (OUTFILE, 'VRMSD = SQRT (VPRESS/&NUMVALFILES);');
       WRITELN (OUTFILE, 'VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));');
       WRITELN (OUTFILE, 'VBIAS = SDIF/&NUMVALFILES;');
       WRITELN (OUTFILE, 'VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));');
{       WRITELN (OUTFILE, 'PROC PRINT DATA = SUMSTATS;');}
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE, 'DATA SUMSTATS; SET SUMSTATS;');
       WRITELN (OUTFILE, 'DROP _TYPE_;');
       WRITELN (OUTFILE, 'DROP _FREQ_;');

       WRITELN (OUTFILE, 'DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;');

       WRITELN (OUTFILE, 'TITLE "CALIBRATION RESULTS";' );
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;' );
{       WRITELN (OUTFILE, '     BY IDERIVAT IFORM IMCVS IGAPS;' );}
       WRITELN (OUTFILE, '     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;' );
       WRITELN (OUTFILE, 'RUN;' );
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'DATA SQUAREDCAL; SET CALCORROUT;' );
       WRITELN (OUTFILE, 'IF _TYPE_ = ','''','CORR', '''',' THEN');
       WRITELN (OUTFILE, '     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;' );
       WRITELN (OUTFILE, 'ELSE' );
       WRITELN (OUTFILE, '     DELETE;' );
{       WRITELN (OUTFILE, 'PROC SORT DATA = SQUAREDCAL; ' );}
 {      WRITELN (OUTFILE, '     BY IDERIVAT IFORM IMCVS IGAPS;' );}
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;' );
{       WRITELN (OUTFILE, '     BY IDERIVAT IFORM IMCVS IGAPS;' );  }
{       WRITELN (OUTFILE, 'PROC PRINT DATA = SQUAREDCAL;');
       WRITELN (OUTFILE, 'RUN;' );                         }

       WRITELN (OUTFILE, 'DATA PREDCAL; SET PREDCHEMANALYTE;');
       WRITELN (OUTFILE, 'IF CHEMANALYTES&X - . THEN DELETE;');
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE, 'DATA PREDCAL; SET PREDCAL;');
       WRITELN (OUTFILE, 'DIF = CHEMANALYTES&X - P_CHEMANALYTE;');
       WRITELN (OUTFILE, 'DSQ = DIF * DIF;');
       WRITELN (OUTFILE);
       WRITELN (OUTFILE, 'PROC SUMMARY;');
       WRITELN (OUTFILE, 'VAR DIF DSQ;');
       WRITELN (OUTFILE, 'OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;');
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE);
       WRITELN (OUTFILE, 'DATA SUMSTATS; SET SUMCAL;');
       WRITELN (OUTFILE, 'PRESS = SDSQ;');
       WRITELN (OUTFILE, 'RMSD = SQRT (PRESS/&NUMCALFILES);');
       WRITELN (OUTFILE, 'SEP = SQRT (PRESS/(&NUMCALFILES - 1));');
       WRITELN (OUTFILE, 'BIAS = SDIF/&NUMCALFILES;');
       WRITELN (OUTFILE, 'SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));');
{       WRITELN (OUTFILE, 'PROC PRINT DATA = SUMSTATS;');  }
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE);
       WRITELN (OUTFILE, 'DATA SUMSTATS; SET SUMSTATS;');
       WRITELN (OUTFILE, 'DROP _TYPE_;');
       WRITELN (OUTFILE, 'DROP _FREQ_;');
       WRITELN (OUTFILE, 'DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;');

       WRITELN (OUTFILE, 'PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;');
       WRITELN (OUTFILE, 'RUN;' );
       WRITELN (OUTFILE);
       WRITELN (OUTFILE, 'DATA DISTANCES; SET PREDCHEMANALYTE;');
       WRITELN (OUTFILE, 'XDIST = SQRT(STDXSSE);');
       WRITELN (OUTFILE, 'YDIST = SQRT(STDYSSE);');
       WRITELN (OUTFILE, 'N = _N_;');
       WRITELN (OUTFILE, 'SYMBOL I=NEEDLES V=DOT C=BLUE;');
       WRITELN (OUTFILE, 'PROC GPLOT DATA = DISTANCES;');
       WRITELN (OUTFILE, 'PLOT XDIST*N /CFRAME=LIGR;');
       WRITELN (OUTFILE, 'PROC GPLOT DATA = DISTANCES;');
       WRITELN (OUTFILE, 'PLOT YDIST*N /CFRAME=LIGR;');
       WRITELN (OUTFILE, 'RUN;');
       

       END;
       WRITELN (OUTFILE, '%MEND PLSTWOAF;');
       WRITELN (OUTFILE);
       WRITELN (OUTFILE);
       CLOSE (OUTFILE);
END.

