%LET DIRECTORY = C:\SEASONALTREATED;

OPTIONS MAUTOSOURCE;
OPTIONS SASAUTOS = ("&DIRECTORY");
X  "CD &DIRECTORY";

/* LINES 8 TO 18 CONTAIN VALUES WHICH MUST BE CHECKED AS DATA SETS ARE CHANGED */
/* LINES 20 TO 45 CONTAIN OPTIONS WHICH MAY OFTEN BE CHANGED      */


            /* ----- MACRO VARIABLES THAT SPECIFY INPUT FILES AND OTHER OPTIONS ----- */

/* SPECTRAL FILE MUST BE GRAMS MULTIFILE (NEWSTYLE, EVEN X SPACING, CONSTANT #PTS PER SPECTRUM) */
%LET MULTIFILE =&DIRECTORY\COMBINED.SPC;

/* CORRESPONDING CONSTITUENT FILE, WITH SAMPLES IN SAME ORDER AS *.SPC FILE */
/* FORM OF GRAMS CFL FILE WITHOUT HEADER INFORMATION */
%LET CHEMFILE =&DIRECTORY\COMPLETE.PRN; /* CORRESPONDING CONSTITUENT FILE, WITH SAMPLES IN SAME ORDER AS *.SPC FILE */

%LET NAMEOFLIBRARY = &DIRECTORY\GRAPHS;
%LET COMBINEDGRAPHS = STORGRAP.TESTCOMBINEDGRAPHS222;

%LET FIRSTFILE = "ODTRT65";    /* ID OF FIRST SAMPLE TO REDUCE XSCORE REPEATS */
%LET MAXINDEX = 700;         /* NUMBER OF WAVELENGTHS PER SPECTRA */
%LET NUMFILES = 241;
%LET MAXVARS = 6;

%LET MAXINDEXPLUS = %SYSEVALF(&MAXINDEX+1);
%LET FIRSTWN = 2500;
%LET LASTWN = 1100;
%LET BYFACTOR = 100;

%LET NUMCALFILES = 241; /* &NUMFILES;  CHANGE IF VALIDATION FILES EXIST */
%LET NUMVALFILES = %SYSEVALF(&NUMFILES - &NUMCALFILES);
%LET FIRSTVALFILE = %SYSEVALF(&NUMCALFILES + 1);
%LET AVSK = "AVER";       /*  SKIP OR AVERAGE EVERY N POINTS*/
%LET RANDOMIZE = "NO";
%LET AVSKFACTOR = 1;      /* NUMBER OF POINTS FOR AVSK */
%LET STARTAT = 1;         /* FIRST SPECTRAL DATAPOINT TO USE */
%LET ENDAT = 700;        /* LAST SPECTRAL DATAPOINT TO USE  */

%LET SGYESNO = "NON";     /* YES IF SAVITSKY=GOLAY DERIVATIVES TO BE USED IN PLS */
%LET MSCYESNO = "YES"; /* YES IF MULTIPLICATIVE SCATTER CORRECTION WANTED */
%LET SNVDETYESNO = "NON"; /* BOTH, SNV OR DET ONLY TO BE BE USED IN PLS */
%LET DETONLY = "NON"; /* DO DETREND ON NON-SNV CORRECTED DATA = DTO*/
%LET MCOPTION = "SAS";    /*MC SET TO PRO (PROGRAM), SAS (SAS), OR NON (NONE) */
%LET SCALE = "NO";       /*SET TO NOSCALE OR BLANK*/
%LET SGFILE = &DIRECTORY\SAVGOLGAP.PRN;  /* LOCATION OF SAVITSKY-GOLAY CONVOLUTION TABLES */
%LET TABLEBG = 1;         /* SET TABLES FOR SAVITSY GOLAY DERIVATIVES */
%LET TABLEEND = 10;
%LET TABLEBY = 1;
%LET BEGINSG = 5;         /* FIRST LINE TO USE  FOR SG DERIVATIVE, MIN = 5*/
%LET ENDSG = 25;          /* LAST LINE TO USE  FOR SG DERIVATIVE, MAX = 25  */

               /* DATA FOR GAP DERIVATIVE */
%LET STARTGAP1ST = 2;   /*1ST ACTUAL GAP = TWICE THIS VALUE */
%LET ENDGAP1ST = 64;
%LET FINALCOUNT1ST = 5;   /*NONE + START TO END BY 2X*/
%LET STARTGAP2ND = 2;   /*1ST ACTUAL GAP = TWICE THIS VALUE */
%LET ENDGAP2ND = 64;
%LET FINALCOUNT2ND = 5;
%LET ODDEVENGAPS = "EVEN"; /* SET TO ODD FOR ODD GAPPED DERIVATIVES */


                     /* MACRO VARIABLE WHICH DO NOT CHANGE */
%LET MAXTEMP = %SYSEVALF (&MAXINDEX * 4);  /* 4*MAXINDEX */
%LET LEFTCUT = 0; /* THE NUMBER OF SPECTRAL POINTS ON LEFT END TO CUT */
%LET RIGHTCUT = 0; /* DITTO FOR RIGHT END */
/*%LET SAVWAVES = &MAXINDEX;*/
%LET INITIALLIMIT = &MAXINDEX;
%LET CHEMS = CHEMANALYTES1-CHEMANALYTES&MAXVARS;
%LET ANALYTES = ID $  &CHEMS;  /* NAMES OF ANALYTES */
%LET PRTANALYTES = ID &CHEMS;  /* FOR PRINTING ONLY */
%LET OUTVARS = &ANALYTES OUTABS1-OUTABS&MAXINDEX;
%LET VARLIST =&ANALYTES ABS1 - ABS&MAXINDEX;
%LET SPECS = IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST;


*MACRO THAT READS A SINGLE NEWSTYLE GRAMS MULTIFILE;

%MACRO GETSPEC;

DATA MULTIFILE;
ARRAY X(&MAXTEMP) X1-X&MAXTEMP;
ARRAY Y(&MAXINDEX) ABS1-ABS&MAXINDEX;
INFILE "&MULTIFILE" RECFM=N;
INPUT @2 SPCVERSION IBR1.;
IF SPCVERSION < 0 THEN SPCVERSION = SPCVERSION + 256;
IF SPCVERSION ^= 75 THEN ABORT;
INPUT @5 NUMPOINTS1 IBR1. NUMPOINTS2 IBR1. @24 +1 NUMSPEC1 IBR1. NUMSPEC2 IBR1. @512;
IF NUMPOINTS1 < 0 THEN NUMPOINTS1 = NUMPOINTS1 + 256;
IF NUMPOINTS2 < 0 THEN NUMPOINTS2 = NUMPOINTS2 + 256;
NUMPOINTS = NUMPOINTS2*256 + NUMPOINTS1;
LEFTEDGE = &LEFTCUT + 1;
ATTRIB CHARLEFT FORMAT = $CHAR.;
CHARLEFT = LEFTEDGE;
CHARLEFT = COMPRESS(CHARLEFT);
CALL SYMPUT('LEFTSPEC',CHARLEFT);
RIGHTEDGE = NUMPOINTS - &RIGHTCUT;
ATTRIB CHARRIGHT FORMAT = $CHAR.;
CHARRIGHT = RIGHTEDGE;
CHARRIGHT = COMPRESS(CHARRIGHT);
CALL SYMPUT('RIGHTSPEC',CHARRIGHT);
NEWNUMPOINTS = NUMPOINTS - &LEFTCUT - &RIGHTCUT;
ATTRIB CHARNEWNUMPOINTS FORMAT = $CHAR.;
CHARNEWNUMPOINTS = NEWNUMPOINTS;
CALL SYMPUT('NEWPOINTS',CHARNEWNUMPOINTS);
IF NUMSPEC1 < 0 THEN NUMSPEC1 = NUMSPEC1 + 256;
IF NUMSPEC2 < 0 THEN NUMSPEC2 = NUMSPEC2 + 256;
NUMRECORDS = NUMSPEC2*256 + NUMSPEC1;
ATTRIB CHARREC FORMAT = $CHAR.;
CHARREC = NUMRECORDS;
CHARREC = COMPRESS(CHARREC);
CALL SYMPUT('NREC',CHARREC);

DO M=1 TO NUMRECORDS;
    IF M = 1 THEN INPUT +2 MULT IBR1. (JUNK1-JUNK6) (IBR1.) +24;
    ELSE INPUT +1 MULT IBR1. (JUNK1-JUNK6) (IBR1.) +24;
    IF MULT < 0 THEN MULT = MULT + 256;
    IF MULT >= 128 THEN MULT = MULT - 256;
    MULT = 2 ** (MULT - 32);

    DO N = 1 TO NUMPOINTS*4;
        INPUT X(N) IBR1.;
    END;

    DO I=4 TO NUMPOINTS*4 BY 4;
        DO J = 0 TO 3 BY 1;
            IF X(I-J) < 0 THEN X(I-J) = X(I-J) + 256;
        END; /* J */

        SIGN = 1;
        IF X(I) >= 128 THEN SIGN = -1;
        K = I / 4;
        Y(K) = ( X(I-3) + X(I-2)*256 + X(I-1)*65536 + X(I)*16777216 );
        IF SIGN < 0 THEN Y(K) = -(4294967296 - Y(K));
        Y(K) = MULT * Y(K);
    END; /* END I */
/*    %IF &MAXINDEX ^= NUMPOINTS %THEN %DO;
            ABORT RETURN;
    %END;*/
    OUTPUT;
END; /* END M */

STOP;
FORMAT ABS1-ABS&MAXINDEX F13.10;
%IF &NUMFILES ^= NUMRECORDS  %THEN %DO;
ABORT RETURN;
%END;
KEEP ABS1-ABS&MAXINDEX;
RUN;

%MEND GETSPEC;


/* MACRO THAT READS AN ASCII FILE THAT CONTAINS ID AND CHEMICAL INFORMATION */

%MACRO GETCHEM;

DATA CHEMDATA;
INFILE "&CHEMFILE";
INPUT &ANALYTES;

DATA CHEMDATA; SET CHEMDATA;
SET NOBS = NUMOFFILES;
IF &NUMFILES ^= NUMOFFILES THEN ABORT ABEND;

DATA WORKFILE;
MERGE MULTIFILE CHEMDATA;
RUN;

DATA RANDOMIZED; SET WORKFILE;

%IF &RANDOMIZE = "YES" %THEN %DO;
RANDOMX = RANUNI (0);
PROC SORT DATA = RANDOMIZED;
BY RANDOMX;
%END;

DATA CAL; SET RANDOMIZED (OBS=&NUMCALFILES);
%IF &RANDOMIZE = "YES" %THEN %DO;
DROP RANDOMX;
%END;
DATA VALIDATION; SET RANDOMIZED (FIRSTOBS=&FIRSTVALFILE);
%IF &RANDOMIZE = "YES" %THEN %DO;
DROP RANDOMX;
%END;
RUN;

DATA VALNODATA; SET VALIDATION;
%DO X = 1 %TO &MAXVARS;
    CHEMANALYTES&X = .;
%END;
RUN;
PROC APPEND BASE = CAL DATA = VALNODATA;
RUN;

DATA WORKFILE; SET CAL;
RUN;

DATA VALIDATION; SET VALIDATION;
FILE "&VALIDATIONFILE";
PUT &ANALYTES;
RUN;


DATA MULTIFILE; SET MULTIFILE;
DROP _ALL_;
DATA CHEMDATA; SET CHEMDATA;
DROP _ALL_;
RUN;

%MEND GETCHEM;


%MACRO OVERHEAD;

DATA WORKFILE; SET WORKFILE;
ARRAY FORM[1] $ IFORM;
ARRAY MCVS[1] $ IMCVS;
ARRAY DERIVAT[1] $ IDERIVAT;
ARRAY GAPS[1] IGAPS;
ARRAY FIRST[1] IFIRST;
ARRAY LAST[1] ILAST;
ARRAY TEMPABS[&MAXINDEX] ABS1-ABS&MAXINDEX;
FORM[1] = 'STR';

IF &MCOPTION = "PRO" THEN
    MCVS[1] = 'PRO';
ELSE IF &MCOPTION = "SAS" THEN
    MCVS[1] = 'SAS';
ELSE
    MCVS[1] = 'NON';


DERIVAT[1] = 'NON';
GAPS[1] = 0;
FIRST[1] = &STARTAT;
LAST[1] = &ENDAT;

DO I = 1 TO (&STARTAT - 1);
    TEMPABS[I] = .;
END;

DO I = (&ENDAT + 1) TO &MAXINDEX;
    TEMPABS[I] = .;
END;

DROP I;

%MEND OVERHEAD;


%MACRO GAPSGDERIVATIVES;

%IF &SGYESNO = "YES" %THEN %DO;

DATA INSAVITSKY; SET WORKFILE;
DATA SAVITSKYDERIVATIVES; SET WORKFILE;
DATA SAVGOL; INFILE &SGFILE;

DO TABLE = 1 TO &TABLEEND;
    DO ROW = 1 TO 14;
        INPUT C1-C11;
        OUTPUT;
    END; /* ROW */
END; /* TABLE */


%DO TABLEINDEX = &TABLEBG %TO &TABLEEND %BY &TABLEBY;
    %IF &TABLEINDEX > 10 %THEN ABORT ABEND;
    DATA CHOSENTABLE; SET SAVGOL;
    IF TABLE ^= &TABLEINDEX THEN DELETE;

    PROC TRANSPOSE DATA=CHOSENTABLE OUT=T_CHOSENTABLE;
        VAR C1-C11;

    %DO LINEINDEX = &BEGINSG %TO &ENDSG %BY 2;
        DATA CONVOLUTE; SET T_CHOSENTABLE;
        SG_PTS = &LINEINDEX;
        RENAME COL1=R1 COL2=R2 COL3=R3 COL4=R4 COL5=R5 COL6=R6 COL7=R7 COL8=R8 COL9=R9
        COL10=R10 COL11=R11 COL12=R12 COL13=R13 COL14=R14;

        IF &TABLEINDEX = 3 OR &TABLEINDEX = 4 OR &TABLEINDEX = 5 OR &TABLEINDEX = 9 THEN
            SIGN = -1;
        ELSE SIGN = 1;

        KEEP SIGN SG_PTS COL1-COL14;
        IF _N_ ^= 13.5 - SG_PTS/2 THEN DELETE;

        PROC SQL BUFFERSIZE=128000;
            CREATE TABLE COMBINED AS
            SELECT *
            FROM CONVOLUTE, INSAVITSKY;


        DATA FINSAVITSKY; SET COMBINED;
        START=IFIRST;
        FINAL=ILAST;
        ARRAY DER[&MAXINDEX];
        ARRAY TEMPABS[&MAXINDEX] ABS1-ABS&MAXINDEX;
        ARRAY R(14) R1-R14;
        LINECOUNTER = FLOOR((&LINEINDEX-3)/2);
        NEWSTART = (SG_PTS+1)/2 + (START-1);
        NEWEND = FINAL - (SG_PTS-1)/2;
        FIRST = NEWSTART;
        LAST = NEWEND;
        ATTRIB CHARSTART FORMAT = $CHAR.;
        CHARSTART = NEWSTART;
        CHARSTART = COMPRESS(CHARSTART);
        CALL SYMPUT('STARTTRIM',CHARSTART);
        ATTRIB CHAREND FORMAT = $CHAR.;
        CHAREND = NEWEND;
        CHAREND = COMPRESS(CHAREND);
        CALL SYMPUT('ENDTRIM',CHAREND);

        DO A = NEWSTART TO NEWEND;
            SUM = 0.0;

            DO AA = (14 - (SG_PTS+1)/2) TO 13;
                SUM = SUM +  R[AA] * TEMPABS[A-(13-AA)];
            END; /* END AA */

            DO AA = (14 - (SG_PTS+1)/2) TO 12;
                SUM = SUM + SIGN * R[AA] * TEMPABS[A+(13-AA)];
            END; /* END AA */

            DER[ A] = SUM / R[14];
        END; /* END A */

        DO X = 1 TO &MAXINDEX;
            TEMPABS[X] = DER[X];
        END; /* END X */

        IF &TABLEINDEX = 1 THEN IDERIVAT = 'SG1';
        ELSE IF &TABLEINDEX = 2 THEN IDERIVAT = 'SG2';
        ELSE IF &TABLEINDEX = 3 THEN IDERIVAT = 'SG3';
        ELSE IF &TABLEINDEX = 4 THEN IDERIVAT = 'SG4';
        ELSE IF &TABLEINDEX = 5 THEN IDERIVAT = 'SG5';
        ELSE IF &TABLEINDEX = 6 THEN IDERIVAT = 'SG6';
        ELSE IF &TABLEINDEX = 7 THEN IDERIVAT = 'SG7';
        ELSE IF &TABLEINDEX = 8 THEN IDERIVAT = 'SG8';
        ELSE IF &TABLEINDEX = 9 THEN IDERIVAT = 'SG9';
        ELSE IF &TABLEINDEX = 10 THEN IDERIVAT = 'SG10';
        IGAPS = LINECOUNTER;
        IFIRST = NEWSTART;
        ILAST = NEWEND;

        IF (&TABLEINDEX = 2 OR &TABLEINDEX = 5 OR &TABLEINDEX = 7) THEN DO;
            IF (LINECOUNTER ^= 1) THEN DO;
                OUTPUT;
                KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
            END; /* END LINECOUNTER DO */
        END;  /* END IF & TABLEINDEX = */

        ELSE DO;
             OUTPUT;
             KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
        END; /* END ELSE */

        %IF ((&TABLEINDEX = 2 OR &TABLEINDEX = 5 OR &TABLEINDEX = 7) AND LINECOUNTER ^= 1) OR
            (&TABLEINDEX ^=2 AND &TABLEINDEX ^=5 AND &TABLEINDEX ^=7)  %THEN %DO;
            PROC APPEND BASE = SAVITSKYDERIVATIVES DATA = FINSAVITSKY;
        %END;
    %END; /* END LINEINDEX1*/
%END; /* END TABLENUM*/

DATA SAVITSKYDERIVATIVES; SET SAVITSKYDERIVATIVES;
IF IDERIVAT = 'NON' THEN DELETE;
RUN;

DATA COMBINED; SET COMBINED;
DROP _ALL_;
DATA FINSAVITSKY; SET FINSAVITSKY;
DROP _ALL_;
DATA CONVOLUTE; SET CONVOLUTE;
DROP _ALL_;
DATA T_CHOSENTABLE; SET T_CHOSENTABLE;
DROP _ALL_;
DATA CHOSENTABLE; SET CHOSENTABLE;
DROP _ALL_;
DATA INSAVITSKY; SET INSAVITSKY;
DROP _ALL_;
DATA SAVGOL; SET SAVGOL;
DROP _ALL_;
RUN;

%END; /*IF SGYESNO = YES*/

%DERIVATIVES;

%MEND GAPSGDERIVATIVES;


%MACRO DERIVATIVES;

DATA FIRST; SET WORKFILE;
ARRAY FIRST[&FINALCOUNT1ST];
ARRAY LAST[&FINALCOUNT1ST];
ARRAY FORM[&FINALCOUNT1ST] $ ;
ARRAY MCVS[&FINALCOUNT1ST] $;
ARRAY GAPS[&FINALCOUNT1ST];
ARRAY DERIVAT[&FINALCOUNT1ST] $ ;

DO I = 1 TO &FINALCOUNT1ST;
    DERIVAT[I] = '1ST';
END;

DO I = 1 TO &FINALCOUNT1ST;
    FORM[I] = IFORM;
    MCVS[I] = IMCVS;
END;

GAP = &STARTGAP1ST;
START = IFIRST;
FINAL = ILAST;
ARRAY TEMP[&MAXINDEX];
ARRAY DER[&FINALCOUNT1ST,&MAXINDEX];
ARRAY TEMPABS[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &FINALCOUNT1ST;
    DO J = 1 TO &MAXINDEX;
        DER[I,J]= TEMPABS[J];
    END; /* END J LOOP */
END; /* END I LOOP */

COUNTER = 0;

DO UNTIL (GAP >= &ENDGAP1ST);
    COUNTER = COUNTER + 1;

    IF &ODDEVENGAPS  = 'EVEN' THEN GAP = GAP*2;
    ELSE IF &ODDEVENGAPS = 'ODD' THEN DO;
        IF GAP = 1 THEN GAP = 2;
        IF GAP = 0.5 THEN GAP = 1;
        GAP = GAP*2 - 1;
    END; /* END ELSE DO */

    GAPS[COUNTER] = GAP;

    DO K = (GAP+START) TO (FINAL-GAP);
        TEMP[K] = DER[COUNTER,K+GAP] - DER[COUNTER,K-GAP];
    END; /* END K LOOP */

    DO L = 1 TO (START + GAP - 1);
        TEMP[L] =  TEMP[START + GAP];
    END;  /* END L LOOP */

    DO M = (FINAL-GAP+1) TO &MAXINDEX;
        TEMP[M] = TEMP[FINAL-GAP];
    END;  /* END M LOOP */

    FIRST[COUNTER] = START;
    LAST[COUNTER] = FINAL;

    DO P = 1 TO &MAXINDEX;
        DER[COUNTER, P] = TEMP[P];
    END; /* END OF P LOOP */
END; /* DO UNTIL END */

DO I = 1 TO &FINALCOUNT1ST;
    IDERIVAT = DERIVAT[I];
    IFORM = FORM[I];
    IMCVS = MCVS[I];
    IGAPS = GAPS[I];
    IFIRST = FIRST[I];
    ILAST = LAST[I];

    DO J = 1 TO &MAXINDEX;
        TEMPABS[J] = DER[I,J];
    END; /* END J LOOP */

    OUTPUT;
    KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
END; /* END I LOOP */
RUN;

DATA SECOND; SET WORKFILE;
ARRAY FIRST[&FINALCOUNT2ND];
ARRAY LAST[&FINALCOUNT2ND];
ARRAY FORM [&FINALCOUNT2ND] $ ;
ARRAY MCVS[&FINALCOUNT2ND] $;
ARRAY GAPS[&FINALCOUNT2ND];
ARRAY DERIVAT[&FINALCOUNT2ND] $ ;

DO I = 1 TO &FINALCOUNT2ND;
    DERIVAT[I] = '2ND';
END;

DO I = 1 TO &FINALCOUNT2ND;
    FORM[I] = IFORM;
    MCVS[I] = IMCVS;
END;

GAP = &STARTGAP2ND;
START=IFIRST;
FINAL = ILAST;
ARRAY TEMP[&MAXINDEX];
ARRAY DER[&FINALCOUNT2ND,&MAXINDEX];
ARRAY TEMPABS[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &FINALCOUNT2ND;
    DO J = 1 TO &MAXINDEX;
        DER[I,J]= TEMPABS[J];
    END; /* END J LOOP */
END; /* END I LOOP */

COUNTER = 0;

DO UNTIL (GAP = &ENDGAP2ND);
    COUNTER = COUNTER + 1;

    IF &ODDEVENGAPS  = 'EVEN' THEN GAP = GAP*2;
    ELSE IF &ODDEVENGAPS = 'ODD' THEN DO;
        IF GAP = 1 THEN GAP = 2;
        IF GAP = 0.5 THEN GAP = 1;
        GAP = GAP*2 - 1;
    END; /* END ELSE DO */

    GAPS[COUNTER] = GAP;

    DO K = (GAP+START) TO (FINAL-GAP);
        TEMP[K] = DER[COUNTER,K+GAP] - 2*DER[COUNTER,K] + DER[COUNTER,K-GAP];
    END; /* END K LOOP */

    DO L = 1 TO (START + GAP - 1);
        TEMP[L] = TEMP[GAP + START];
    END; /* END L LOOP */

    DO M = (FINAL-GAP+1) TO &MAXINDEX;
        TEMP[M] = TEMP[FINAL - GAP];
    END;   /* END M LOOP */

    FIRST[COUNTER] = START;
    LAST[COUNTER] = FINAL;

    DO P = 1 TO &MAXINDEX;
        DER[COUNTER, P] = TEMP[P];
    END; /* END OF P LOOP */
END; /* DO UNTIL END */

DO I = 1 TO &FINALCOUNT2ND;
    IDERIVAT = DERIVAT[I];
    IFORM = FORM[I];
    IMCVS = MCVS[I];
    IGAPS = GAPS[I];
    IFIRST = FIRST[I];
    ILAST = LAST[I];

    DO J = 1 TO &MAXINDEX;
        TEMPABS[J] =  DER[I,J];
    END; /* END J LOOP */

    OUTPUT;
    KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
END; /* END I LOOP */

RUN;

PROC APPEND BASE = WORKFILE DATA = FIRST;
PROC APPEND BASE = WORKFILE DATA = SECOND;

%IF &SGYESNO  =  "YES" %THEN %DO;
    PROC APPEND BASE = WORKFILE DATA = SAVITSKYDERIVATIVES;
%END; /* END IF */

RUN;

DATA WORKFILE; SET WORKFILE;
ARRAY TEMP[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO (IFIRST - 1);
    TEMP[I] = .;
END; /* I */

DO I = (ILAST + 1) TO &MAXINDEX;
    TEMP[I] = .;
END; /* END I */

DATA FIRST; SET FIRST;
DROP _ALL_;
DATA SECOND; SET SECOND;
DROP _ALL_;
DATA SAVITSKYDERIVATIVES; SET SAVITSKYDERIVATIVES;
DROP _ALL_;

%MEND DERIVATIVES;


%MACRO SKIPAVER;

DATA SKIPAVER; SET WORKFILE;
ARRAY ALLDATA[&MAXINDEX] ABS1-ABS&MAXINDEX;
ARRAY ASDATA[&MAXINDEX];

IF &AVSK = 'SKIP' THEN DO;
    SAVWAVES =  FLOOR ((ILAST-IFIRST)/&AVSKFACTOR);
    ALLDATA[1] = ALLDATA[IFIRST];

    DO I = 1 TO (SAVWAVES);
        ALLDATA[I+1] = ALLDATA[IFIRST + I*&AVSKFACTOR];
    END; /* END I LOOP */

    ILAST = SAVWAVES + 1;
    IFIRST = 1;
END; /* END SKIP IF LOOP */

IF &AVSK = 'AVER' THEN DO;
    SAVWAVES = FLOOR ((ILAST-IFIRST + 1)/&AVSKFACTOR);
    COUNTER = IFIRST-1;
    REMAINDER = (ILAST - IFIRST + 1) - SAVWAVES*&AVSKFACTOR;

    DO I = 1 TO (SAVWAVES);
        ASDATA[I] = 0;

        DO J = 1 TO &AVSKFACTOR;
            COUNTER = COUNTER + 1;
            ASDATA[I] = ASDATA[I] + ALLDATA[COUNTER];
        END;  /* END J LOOP */

        ALLDATA[I] = ASDATA[I]/&AVSKFACTOR;
        IFIRST = 1;
    END; /* I LOOP */

    IF REMAINDER > 0 THEN DO;
        SAVWAVES = SAVWAVES + 1;
        ASDATA[SAVWAVES] = 0;

        DO K = 1 TO REMAINDER;
            COUNTER = COUNTER + 1;
            ASDATA[SAVWAVES] = ASDATA[SAVWAVES] + ALLDATA[COUNTER];
        END; /* END K LOOP */

        ALLDATA[SAVWAVES] = ASDATA[SAVWAVES]/REMAINDER;
    END; /* END IF DO LOOP */

    ILAST = SAVWAVES;
END; /* END IF DO LOOP */

IF ILAST < &MAXINDEX THEN;

    DO L = (ILAST + 1) TO &MAXINDEX;
        ALLDATA[L] = 0.0;
    END; /* END DO L */

PROC SORT DATA = SKIPAVER;
    BY IDERIVAT IFORM IMCVS IGAPS;

DATA WORKFILE; SET SKIPAVER;
ARRAY TEMP[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO (IFIRST - 1);
    TEMP[I] = .;
END;

DO I = (ILAST + 1) TO &MAXINDEX;
    TEMP[I] = .;
END;

%LET MAXINDEX = %SYSEVALF(&MAXINDEX/&AVSKFACTOR, CEIL); /* STORAGE ONLY LIMITS */

DATA WORKFILE; SET WORKFILE;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
DATA SKIPAVER; SET SKIPAVER;
DROP _ALL_;
RUN;

%MEND SKIPAVER;


%MACRO MSCSNV;

%LET MINVARLIST =&CHEMS ABS1-ABS&MAXINDEX;
%LET MANALYTES = &CHEMS;

%IF &MSCYESNO  =  "YES" %THEN %DO;

DATA FORMSC; SET WORKFILE;
        IF CHEMANALYTES1 EQ  . THEN DELETE;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

PROC MEANS DATA = FORMSC NOPRINT;                      /* COMPUTE MEAN SPECTRUM */
    BY IDERIVAT IFORM IMCVS IGAPS;
    VAR &MINVARLIST;
    OUTPUT OUT = MNSPEC
    MEAN =  &MINVARLIST;
RUN;

DATA MEANSPEC; SET MNSPEC;
PROC TRANSPOSE DATA = MNSPEC OUT = AVERSPEC  PREFIX = MEANABS NAME=PKNUM;
    BY IDERIVAT IFORM IMCVS IGAPS;
    VAR ABS1-ABS&MAXINDEX;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS PKNUM;

                           /* COMPUTATION OF MSC DATA */
DATA ORGSPECS; SET WORKFILE;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;
PROC TRANSPOSE DATA = ORGSPECS OUT = LORGSPEC PREFIX = ABSES NAME=PKNUM;
    BY IDERIVAT IFORM IMCVS IGAPS ID;
    VAR ABS1-ABS&MAXINDEX;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS PKNUM;

DATA MORGSPEC; MERGE LORGSPEC AVERSPEC;
    BY IDERIVAT IFORM IMCVS IGAPS PKNUM;
PROC SORT DATA = MORGSPEC;
    BY IDERIVAT IFORM IMCVS IGAPS ID PKNUM;

PROC REG DATA = MORGSPEC OUTEST = REGOUT NOPRINT;
    BY IDERIVAT IFORM IMCVS IGAPS ID;
    MODEL ABSES1 = MEANABS1;
RUN;

DATA REGOUT; SET REGOUT;
SLOPE = MEANABS1;
INTERCEPT = INTERCEPT;
DROP MEANABS1 ABSES1;
PROC SORT;
    BY IDERIVAT IFORM IMCVS IGAPS ID;

DATA ORGSPECS; SET ORGSPECS;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

DATA FINALMSC; MERGE ORGSPECS REGOUT; BY IDERIVAT IFORM IMCVS IGAPS ID;
IFORM =  'MSC';

DATA FINALMSC; SET FINALMSC;
ARRAY MSCABS[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &MAXINDEX;
    MSCABS[I] = (MSCABS[I] - INTERCEPT) /SLOPE;
END;

KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
RUN;

%END; /*IF MSC = YES */


%IF (&SNVDETYESNO  =  "BOTH") OR (&SNVDETYESNO  =  "SNV") %THEN %DO;

DATA FINALSNV; SET WORKFILE;
ARRAY MNARRAY[&MAXINDEX] ABS1 - ABS&MAXINDEX;
ARRAY SQARRAY[&MAXINDEX];
MNSPEC= 0;

DO I = IFIRST TO ILAST;
    MNSPEC = MNSPEC + MNARRAY[I];
END; /* END DO I */

MNSPEC = MNSPEC/(ILAST - IFIRST + 1);

DO I = IFIRST TO ILAST;
    MNARRAY[I] = MNARRAY[I]- MNSPEC;
END; /* END DO I */

DO I = IFIRST TO ILAST;
    SQARRAY[I] = MNARRAY[I]*MNARRAY[I];
END; /* END DO I */

MNSUM = 0;

DO I = IFIRST TO ILAST;
    MNSUM = MNSUM + SQARRAY[I];
END; /* END DO I */

SQRTMNSUM = SQRT(MNSUM/(ILAST - IFIRST));

DO I = IFIRST TO ILAST;
    MNARRAY[I] = MNARRAY[I] / SQRTMNSUM;
END; /* END DO I */

DATA FINALSNV; SET FINALSNV;
ARRAY FORM[1] $ IFORM;
FORM[1] = 'SNV';

KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

%END; /* IF BOTH OR SNV */


%IF (&SNVDETYESNO  =  "BOTH") OR (&SNVDETYESNO  =  "DET") %THEN %DO;

DATA FINALDETREND; SET FINALSNV;
ARRAY FORM[1] $ IFORM;
FORM[1] = 'DET';

PROC SORT DATA = FINALDETREND;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

PROC TRANSPOSE DATA = FINALDETREND OUT = TRANSSNV PREFIX = ABSORB NAME = PKNUM;
    BY ID IDERIVAT IFORM IMCVS IGAPS;
    VAR ABS1-ABS&MAXINDEX;

DATA ALL; SET TRANSSNV;
N = _N_;
X = FLOOR ((N - 1)/&MAXINDEX);
I = N - X*&MAXINDEX;
II = I*I;

PROC REG OUTEST = OUTALL NOPRINT; BY ID IDERIVAT IFORM IMCVS IGAPS;
    MODEL ABSORB1 = I II;
RUN;

DATA OUTALL; SET OUTALL;
INTERCEPT = INTERCEPT;
COEFF1 = I;
COEFF2 = II;
DROP I II _MODEL_ _TYPE_ _DEPVAR_ _RMSE_ ABSORB1;
PROC SORT DATA = OUTALL;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

DATA NEWALL; MERGE FINALDETREND OUTALL;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

DATA COMPUTED; SET NEWALL;
ARRAY DTARRAY[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &MAXINDEX;
    II = I*I;
    DTARRAY[I] = DTARRAY[I] - (INTERCEPT + I*COEFF1 + II*COEFF2);
END; /* END DO I */

DATA DETREND; SET COMPUTED;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

%END; /*IF BOTH OR DET ONLY */

%IF &DETONLY =  "YES" %THEN %DO;

DATA FINALDETREND; SET WORKFILE;
ARRAY FORM[1] $ IFORM;
FORM[1] = 'DTO';

PROC SORT DATA = FINALDETREND;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

PROC TRANSPOSE DATA = FINALDETREND OUT = TRANSSNV PREFIX = ABSORB NAME = PKNUM;
    BY ID IDERIVAT IFORM IMCVS IGAPS;
    VAR ABS1-ABS&MAXINDEX;

DATA ALL; SET TRANSSNV;
N = _N_;
X = FLOOR ((N - 1)/&MAXINDEX);
I = N - X*&MAXINDEX;
II = I*I;

PROC REG OUTEST = OUTALL NOPRINT; BY ID IDERIVAT IFORM IMCVS IGAPS;
    MODEL ABSORB1 = I II;
RUN;

DATA OUTALL; SET OUTALL;
INTERCEPT = INTERCEPT;
COEFF1 = I;
COEFF2 = II;
DROP I II _MODEL_ _TYPE_ _DEPVAR_ _RMSE_ ABSORB1;
PROC SORT DATA = OUTALL;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

DATA NEWALL; MERGE FINALDETREND OUTALL;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

DATA COMPUTED; SET NEWALL;
ARRAY DTARRAY[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &MAXINDEX;
    II = I*I;
    DTARRAY[I] = DTARRAY[I] - (INTERCEPT + I*COEFF1 + II*COEFF2);
END; /* END DO I */

DATA DETRENDONLY; SET COMPUTED;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

%END; /*IF DETONLY */


DATA COMBINED; SET WORKFILE;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

%IF &MSCYESNO  =  "YES" %THEN %DO;
    PROC APPEND BASE = COMBINED DATA=FINALMSC;
%END;

%IF (&SNVDETYESNO  =  "BOTH") OR (&SNVDETYESNO  =  "SNV") %THEN %DO;
    PROC APPEND BASE = COMBINED DATA = FINALSNV;
%END;

%IF (&SNVDETYESNO  =  "BOTH") OR (&SNVDETYESNO  =  "DET") %THEN %DO;
    PROC APPEND BASE = COMBINED DATA = DETREND;
%END;

%IF (&DETONLY =  "YES") %THEN %DO;
    PROC APPEND BASE = COMBINED DATA = DETRENDONLY;
%END;

DATA WORKFILE; SET COMBINED;
RUN;
DATA ORGSPECS; SET ORGSPECS;
DROP _ALL_;
DATA REGOUT; SET REGOUT;
DROP _ALL_;
DATA MORGSPEC; SET MORGSPEC;
DROP _ALL_;
DATA LORGSPEC; SET LORGSPEC;
DROP _ALL_;
DATA AVERSPEC; SET AVERSPEC;
DROP _ALL_;
DATA MEANSPEC; SET MEANSPEC;
DROP _ALL_;
DATA MNSPEC; SET MNSPEC;
DROP _ALL_;
DATA TRANSSNV; SET TRANSSNV;
DROP _ALL_;
DATA FINALDETREND; SET FINALDETREND;
DROP _ALL_;
DATA ALL; SET ALL;
DROP _ALL_;
DATA OUTALL; SET OUTALL;
DROP _ALL_;
DATA NEWALL; SET NEWALL;
DROP _ALL_;
DATA COMPUTED; SET COMPUTED;
DROP _ALL_;
DATA DETREND; SET DETREND;
DROP _ALL_;
DATA COMBINED; SET COMBINED;
DROP _ALL_;
DATA FINALSNV; SET FINALSNV;
DROP _ALL_;
DATA FINALMSC; SET FINALMSC;
DROP _ALL_;
RUN;

%MEND MSCSNV;


%MACRO MEANCENTERVARSCALED;

%LET MINVARLIST = &CHEMS ABS1-ABS&MAXINDEX;
%LET MEANVARS = MCHEMS1-MCHEMS&MAXVARS MABS1-MABS&MAXINDEX;
%LET STDVARS = SCHEMS1-SCHEMS&MAXVARS SABS1-SABS&MAXINDEX;
%LET VARLIST = &PRTANALYTES ABS1 - ABS&MAXINDEX;   /* NEEDED AS WRITTEN HERE */
%LET MCVARS = ID  MCCHEMS1-MCCHEMS&MAXVARS MCABS1 - MCABS&MAXINDEX;
%LET VSVARS =  ID  VSCHEMS1-VSCHEMS&MAXVARS VSABS1 - VSABS&MAXINDEX;

DATA MSVAR; SET WORKFILE;
IF CHEMANALYTES1 EQ  . THEN DELETE;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS;

PROC MEANS DATA = MSVAR NOPRINT;
    BY  IDERIVAT IFORM IMCVS IGAPS;
    VAR &MINVARLIST;
    OUTPUT OUT = MCVARSCALED
    MEAN =  &MEANVARS STD = &STDVARS;
PROC SORT DATA=MCVARSCALED;
    BY  IDERIVAT IFORM IMCVS IGAPS;

DATA WORKFILE; SET WORKFILE;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS;

DATA MERGEDMSVARMCVARSCALED;
MERGE WORKFILE MCVARSCALED;
    BY  IDERIVAT IFORM IMCVS IGAPS;

DATA MEANCENTERED; SET MERGEDMSVARMCVARSCALED;
ARRAY MCARRABS[&MAXINDEX] ABS1-ABS&MAXINDEX;
ARRAY MARRABS[&MAXINDEX] MABS1-MABS&MAXINDEX;
ARRAY CENTEREDCHEMS[&MAXVARS] &CHEMS;
ARRAY MEANCHEMS[&MAXVARS] MCHEMS1 - MCHEMS&MAXVARS;

DO I = IFIRST TO ILAST;
    MCARRABS[I] = MCARRABS[I] - MARRABS[I];
END; /* END I LOOP */

DO I = 1 TO &MAXVARS;
    CENTEREDCHEMS[I] = CENTEREDCHEMS[I] - MEANCHEMS[I];
END;  /*END I LOOP*/

IMCVS = 'MCN';

DATA VARSCALED; SET MERGEDMSVARMCVARSCALED;
ARRAY VSARRABS[&MAXINDEX] ABS1-ABS&MAXINDEX;
ARRAY MARRABS[&MAXINDEX] MABS1-MABS&MAXINDEX;
ARRAY SARRABS[&MAXINDEX] SABS1-SABS&MAXINDEX;
ARRAY VSCHEMS[&MAXVARS] CHEMANALYTES1-CHEMANALYTES&MAXVARS;
ARRAY MEANCHEMS[&MAXVARS] MCHEMS1 - MCHEMS&MAXVARS;
ARRAY STDCHEMS[&MAXVARS] SCHEMS1 - SCHEMS&MAXVARS;

DO I = IFIRST TO ILAST;
    VSARRABS[I] = (VSARRABS[I] - MARRABS[I])  / SARRABS[I];
END; /* END I LOOP */

DO I = 1 TO &MAXVARS;
    VSCHEMS[I] = (VSCHEMS[I] - MEANCHEMS[I]) / STDCHEMS[I];
END;  /*END I LOOP*/

IMCVS = 'VSC';
OUTPUT;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;

DATA SAVVARIANCES; SET MERGEDMSVARMCVARSCALED;
IF ID = &FIRSTFILE;
KEEP IDERIVAT IFORM IMCVS IGAPS SCHEMS1-SCHEMS&MAXVARS;

%IF &MCOPTION = "PRO" %THEN %DO;

DATA MEANCENTERED; SET MEANCENTERED;
OUTPUT;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;


PROC APPEND BASE = WORKFILE DATA = MEANCENTERED;
PROC APPEND BASE = WORKFILE DATA  = VARSCALED;

%END; /* END IF MCOPTION = PRO */

DATA MSVAR; SET MSVAR;
DROP _ALL_;
DATA MCVARSCALED; SET MCVARSCALED;
DROP _ALL_;
DATA MERGEDMSVARMCVARSCALED; SET MERGEDMSVARMCVARSCALED;
DROP _ALL_;
DATA MEANCENTERED; SET MEANCENTERED;
DROP _ALL_;
DATA VARSCALED; SET VARSCALED;
DROP _ALL_;
RUN;

%MEND MEANCENTERVARSCALED;


%MACRO PREPAREFORPLS;
DATA WORKFILE; SET WORKFILE;
ARRAY SPECTRA[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &MAXINDEX;
    IF SPECTRA[I] = . THEN SPECTRA[I] = 0.0;
END; /* END DO I */

PROC SORT DATA = WORKFILE;
    BY IDERIVAT IFORM IMCVS IGAPS;

DATA WORKFILE; SET WORKFILE;
OUTPUT;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;

%MEND PREPAREFORPLS;



%MACRO PRINTCORRELATIONPLOTS;

DATA TEST; SET WORKFILE;


%DO VARX = 1 %TO &MAXVARS;

PROC CORR DATA = TEST OUT = T_CORR NOPRINT; BY IDERIVAT IFORM IMCVS IGAPS;
VAR ABS1-ABS&MAXINDEX; WITH CHEMANALYTES&VARX ;
RUN;

DATA T_CORR; SET T_CORR;
IF _TYPE_ = "CORR";
DROP _TYPE_;
RUN;

DATA SAVECORR; SET T_CORR;
ARRAY CORRS[&MAXINDEX] ABS1-ABS&MAXINDEX;
FILE "SAVCORRPLOT.TXT";
DO I = 1 TO &MAXINDEX;
PUT _NAME_ $ 15. IDERIVAT $ IFORM $ IMCVS $ IGAPS I CORRS[I];
END;
RUN;



DATA FORGPLOT; INFILE "SAVCORRPLOT.TXT";
INPUT  NAME $ 15. IDERIVAT $ IFORM $ IMCVS $ IGAPS I CORRELATION;
FACTOR = (&FIRSTWN - &LASTWN) / (&MAXINDEX);
WN =I*FACTOR + &LASTWN - FACTOR;
RUN;

DATA FORGPLOT; SET FORGPLOT;
RSQUARE = CORRELATION*CORRELATION;
I = -I;
WN = - WN;

PROC PRINTTO;
RUN;

PROC FORMAT ;
PICTURE  REVERSE
LOW - < 0  = '0999'
0 < - HIGH = '0999' (PREFIX = '-')
0                = '0999';
RUN;

%LET FIRSTWN = %SYSEVALF(&FIRSTWN, FLOOR);
%LET LASTWN = %SYSEVALF(&LASTWN, FLOOR);

AXIS1 ORDER = (-&FIRSTWN TO - &LASTWN BY &BYFACTOR)
            LABEL = (FONT = SWISSB 'WAVELENGTH NM')
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER = 8)
            MINOR = (WIDTH = 10 NUMBER = 10);
AXIS2 LABEL = (FONT = SWISSB ANGLE = 90 'CORRELATION')
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER = 8)
            MINOR = (WIDTH = 10 NUMBER = 10);

AXIS3 LABEL = (FONT = SWISSB ANGLE = 90 'RSQUARE')
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER = 8)
            MINOR = (WIDTH = 10 NUMBER = 10);

GOPTION LFACTOR = 1 FTEXT = SWISSB;
RUN;


SYMBOL I=JOIN LINE = 1 WIDTH = 10 C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
FORMAT WN REVERSE.;
BY NAME IDERIVAT IFORM IMCVS IGAPS;
PLOT CORRELATION * WN/ HAXIS = AXIS1 VAXIS = AXIS2;
PLOT RSQUARE * WN/ HAXIS = AXIS1 VAXIS = AXIS3;
%END;
%MEND;


%MACRO PRINTSPECTRALPLOTS;

DATA TEST; SET WORKFILE;
ABS&MAXINDEX = .;
ABS1 = .;

DATA SAVESPECTRA; SET TEST;
ARRAY SPECTRUM[&MAXINDEX] ABS1-ABS&MAXINDEX;
FILE "SAVSPECTRA.TXT";
FACTOR = (&FIRSTWN - &LASTWN) / (&MAXINDEX);
DO I = 1 TO &MAXINDEX;
WN = I*FACTOR + &LASTWN - FACTOR;
PUT ID $ I WN SPECTRUM[I];
END;
RUN;

DATA FORGPLOT; INFILE "SAVSPECTRA.TXT";
INPUT ID $ I WN ABSORBANCE;
I = -I;
WN = - WN;
RUN;

PROC SORT DATA = FORGPLOT;
BY ID I;
RUN;

PROC FORMAT ;
PICTURE  REVERSE
LOW - < 0  = '0999'
0 < - HIGH = '0999' (PREFIX = '-')
0                = '0999';
RUN;

%LET FIRSTWN = %SYSEVALF(&FIRSTWN);
%LET LASTWN = %SYSEVALF(&LASTWN, CEIL);

AXIS1 ORDER = (-&FIRSTWN TO -&LASTWN BY &BYFACTOR)
            LABEL = (FONT = SWISSB 'WAVELENGTH NM' )
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER =4)
            MINOR = (WIDTH = 10 NUMBER = 10);
AXIS2 LABEL = (FONT = SWISSB ANGLE = 90 'ABSORBANCE')
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER = 8)
            MINOR = (WIDTH = 10 NUMBER = 10);

GOPTION LFACTOR = 1 FTEXT = SWISSB;
RUN;
SYMBOL LINE = 1 WIDTH = 10 I=JOIN C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
       FORMAT WN REVERSE.;
PLOT ABSORBANCE*WN/OVERLAY SKIPMISS HAXIS = AXIS1
VAXIS = AXIS2;


GOPTION LFACTOR = 1;
RUN;
SYMBOL LINE = 1 WIDTH = 10 I=JOIN C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
BY ID;
FORMAT WN REVERSE.;
PLOT ABSORBANCE*WN/OVERLAY SKIPMISS HAXIS = AXIS1
VAXIS = AXIS2;

%MEND;


%MACRO VIEWCORRELATIONPLOTS;

DATA TEST; SET WORKFILE;

%DO VARX = 1 %TO &MAXVARS;
PROC CORR DATA = TEST OUT = T_CORR NOPRINT; BY IDERIVAT IFORM IMCVS IGAPS;
VAR ABS1-ABS&MAXINDEX; WITH CHEMANALYTES&VARX ;
RUN;

DATA T_CORR; SET T_CORR;
IF _TYPE_ = "CORR";
DROP _TYPE_;
RUN;

DATA SAVECORR; SET T_CORR;
ARRAY CORRS[&MAXINDEX] ABS1-ABS&MAXINDEX;
FILE "SAVCORRPLOT.TXT";
DO I = 1 TO &MAXINDEX;
PUT _NAME_ $ 15. IDERIVAT $ IFORM $ IMCVS $ IGAPS I CORRS[I];
END;
RUN;



DATA FORGPLOT; INFILE "SAVCORRPLOT.TXT";
INPUT  NAME $ 15. IDERIVAT $ IFORM $ IMCVS $ IGAPS I CORRELATION;
FACTOR = (&FIRSTWN - &LASTWN) / (&MAXINDEX);
WN =I*FACTOR + &LASTWN - FACTOR;
RUN;

DATA FORGPLOT; SET FORGPLOT;
RSQUARE = CORRELATION*CORRELATION;
I = -I;
WN = - WN;

PROC PRINTTO;
RUN;

PROC FORMAT ;
PICTURE  REVERSE
LOW - < 0  = '0999'
0 < - HIGH = '0999' (PREFIX = '-')
0                = '0999';
RUN;

%LET FIRSTWN = %SYSEVALF(&FIRSTWN, FLOOR);
%LET LASTWN = %SYSEVALF(&LASTWN, FLOOR);

AXIS1 ORDER = (-&FIRSTWN TO - &LASTWN BY &BYFACTOR)
            LABEL = (FONT = SWISSB 'WAVELENGTH NM' )
            WIDTH = 1
            MAJOR = (WIDTH = 1 NUMBER = 8)
            MINOR = (WIDTH = 1 NUMBER = 10);
AXIS2 LABEL = (FONT = SWISSB ANGLE = 90 'CORRELATION')
            WIDTH = 1
            MAJOR = (WIDTH = 1 NUMBER = 8)
            MINOR = (WIDTH = 1 NUMBER = 10);

AXIS3 LABEL = (FONT = SWISSB ANGLE = 90 'RSQUARE')
            WIDTH = 1
            MAJOR = (WIDTH = 1 NUMBER = 8)
            MINOR = (WIDTH = 1 NUMBER = 10);

GOPTION LFACTOR = 1 FTEXT = SWISSB;
RUN;
SYMBOL I=JOIN LINE = 1 WIDTH = 1 C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
FORMAT WN REVERSE.;
BY NAME IDERIVAT IFORM IMCVS IGAPS;
PLOT CORRELATION*WN/ HAXIS = AXIS1
VAXIS = AXIS2;
PLOT RSQUARE*WN/ HAXIS = AXIS1
VAXIS = AXIS3;
%END;
%MEND;


%MACRO VIEWSPECTRALPLOTS;

DATA TEST; SET WORKFILE;
ABS&MAXINDEX = .;
ABS1 = .;

DATA SAVESPECTRA; SET TEST;
ARRAY SPECTRUM[&MAXINDEX] ABS1-ABS&MAXINDEX;
FILE "SAVSPECTRA.TXT";
FACTOR = (&FIRSTWN - &LASTWN)/&MAXINDEX;
DO I = 1 TO &MAXINDEX;
WN = I*FACTOR + &LASTWN - FACTOR;
PUT ID $ IDERIVAT $ IFORM $ IMCVS $ IGAPS I WN SPECTRUM[I] FACTOR;
END;
RUN;

DATA FORGPLOT; INFILE "SAVSPECTRA.TXT";
INPUT ID $ IDERIVAT $ IFORM $ IMCVS $ IGAPS I WN ABSORBANCE;
I = -I;
WN = - WN;
RUN;

PROC SORT DATA = FORGPLOT;
BY IDERIVAT IFORM IMCVS IGAPS ID I;
RUN;

PROC FORMAT ;
PICTURE  REVERSE
LOW - < 0  = '0999'
0 < - HIGH = '0999' (PREFIX = '-')
0                = '0999';
RUN;

%LET FIRSTWN = %SYSEVALF(&FIRSTWN);
%LET LASTWN = %SYSEVALF(&LASTWN, CEIL);

AXIS1 ORDER = (-&FIRSTWN TO -&LASTWN BY &BYFACTOR)
            LABEL = (FONT = SWISSB 'WAVELENGTH NM' )
            WIDTH = 1
            MAJOR = (WIDTH = 1 NUMBER =4)
            MINOR = (WIDTH = 1 NUMBER = 10);
AXIS2 LABEL = (FONT = SWISSB ANGLE = 90 'ABSORBANCE')
            WIDTH = 1
            MAJOR = (WIDTH = 1 NUMBER = 8)
            MINOR = (WIDTH = 1 NUMBER = 10);

GOPTION LFACTOR = 1 FTEXT = SWISSB;
RUN;
SYMBOL LINE = 1 WIDTH = 1 I=JOIN C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
       FORMAT WN REVERSE.;
           BY IDERIVAT IFORM IMCVS IGAPS;
PLOT ABSORBANCE*WN/OVERLAY SKIPMISS HAXIS = AXIS1
VAXIS = AXIS2;


GOPTION LFACTOR = 1;
RUN;
SYMBOL LINE = 1 WIDTH = 1 I=JOIN C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
BY IDERIVAT IFORM IMCVS IGAPS ID;
FORMAT WN REVERSE.;
PLOT ABSORBANCE*WN/OVERLAY SKIPMISS HAXIS = AXIS1
VAXIS = AXIS2;

%MEND;

%MACRO PRINTLIMITEDSPECTRALPLOTS;

DATA TEST; SET LIMITED;

DATA SAVESPECTRA; SET TEST;
ARRAY SPECTRUM[&MAXINDEX] ABS1-ABS&MAXINDEX;
FILE "SAVSPECTRA.TXT";
FACTOR = (&FIRSTWN - &LASTWN) / (&MAXINDEX);
DO I = 1 TO &MAXINDEX;
WN = I*FACTOR + &LASTWN - FACTOR;
PUT ID $ I WN SPECTRUM[I];
END;
RUN;

DATA FORGPLOT; INFILE "SAVSPECTRA.TXT";
INPUT ID $ I WN ABSORBANCE;
I = -I;
WN = - WN;
RUN;

PROC SORT DATA = FORGPLOT;
BY ID I;
RUN;

PROC FORMAT ;
PICTURE  REVERSE
LOW - < 0  = '0999'
0 < - HIGH = '0999' (PREFIX = '-')
0                = '0999';
RUN;

%LET FIRSTWN = %SYSEVALF(&FIRSTWN, FLOOR);
%LET LASTWN = %SYSEVALF(&LASTWN, FLOOR);

AXIS1 ORDER = (-&FIRSTWN TO -&LASTWN BY &BYFACTOR)
            LABEL = (FONT = SWISSB 'WAVELENGTH NM' )
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER =4)
            MINOR = (WIDTH = 10 NUMBER = 10);
AXIS2 LABEL = (FONT = SWISSB ANGLE = 90 'ABSORBANCE')
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER = 8)
            MINOR = (WIDTH = 10 NUMBER = 10);

GOPTION LFACTOR = 1 FTEXT = SWISSB;
RUN;
SYMBOL LINE = 1 WIDTH = 10 I=JOIN C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
       FORMAT WN REVERSE.;
PLOT ABSORBANCE*WN/OVERLAY SKIPMISS HAXIS = AXIS1
VAXIS = AXIS2;

%MEND;

%GETSPEC
RUN;
%GETCHEM
RUN;

%OVERHEAD
RUN;
%GAPSGDERIVATIVES
RUN;
%SKIPAVER
RUN;
%MSCSNV
RUN;
%MEANCENTERVARSCALED
RUN;
%PREPAREFORPLS
RUN;

LIBNAME STORGRAP ("&NAMEOFLIBRARY");
RUN;

PROC PRINTTO;
RUN;

%VIEWSPECTRALPLOTS
RUN;
DATA LIMITED; SET WORKFILE;
IF (ID = &FIRSTFILE);
RUN;
%PRINTLIMITEDSPECTRALPLOTS
RUN;
%PRINTSPECTRALPLOTS
RUN;
%VIEWCORRELATIONPLOTS
RUN;
%PRINTCORRELATIONPLOTS
RUN;
